%Mecatrnica. Control y Automatizacin. 2013
%Fernando Reyes Corts, Jaime Cid Monjaraz y Emilio Vargas Soto
%Alfaomega  "Te acerca al conocimiento"


clc; 
clear all; 
close all;
format short g
%parmetros de simulacin ------------------------------------------------\%
    ti=0; %tiempo inicial (segundos)
    tf=10; %tiempo de final (segundos)
    h=0.001; %incremento de tiempo (segundos)
    ts=ti:h:tf; %vector de tiempo
    ci=[0;0]; %condiciones iniciales
    opciones=odeset('RelTol',1e-3,'InitialStep',1e-3,'MaxStep',1e-3);
%solucin numrica del sistema -------------------------------------------\%
[t,x]=ode45('pendulo',ts,ci,opciones);
    q1=x(:,1);
    qp1=x(:,2);
   [n,m]=size(t);
   tau1=zeros(n,1);
   qt1=zeros(n,1);
   
   for  k=1:n   
    [tau1(k), qt1(k)] =pdpendulo(q1(k),qp1(k));
   end
  
    
subplot(3,1,1); plot(t,180*qt1/pi)
subplot(3,1,2); plot( t, 180*q1/pi)
subplot(3,1,3); plot(t,tau1)
%subplot(2,2,4); plot(qt1, qp1)
