%Mecatrnica. Control y Automatizacin. 2013
%Fernando Reyes Corts, Jaime Cid Monjaraz y Emilio Vargas Soto
%Alfaomega  "Te acerca al conocimiento"

function  xp=pendulo(t,x)
%modelo dinmico del pndulo
%no se incluye el fenmeno de friccin de Coulomb, ni esttica
%variables de  estados (entradas) --------------------------------------------\%
%posicin articular
q1=x(1);  
%velocidad articular
qp1=x(2); 
%parmetros del pndulo --------------------------------------------------\%
    m1=5;      %masa
    lc1=0.01;  %centro de gravedad
    g=9.81;   %constante de aceleracin gravitacional
    b1=0.17;   %coeficiente de friccin viscosa
    Ir1=0.16;  %momento de inercia del rotor
 Ip1=Ir1+m1*lc1*lc1; %momento de inercia del pndulo

%en este punto se inserta el algoritmo de control
%par aplicado (controlador) ----------------------------------------------\%
%    [tau1, ~]= pdpendulo(q1,qp1);
    [tau1, ~]= tanhpendulo(q1,qp1);
   
 %aceleracin articular del pndulo ---------------------------------------------\%
    qpp1=(tau1-b1*qp1-m1*g*lc1*sin(q1))/Ip1;

%vector de salida --------------------------------------------------------\%
    xp=[qp1;    %xp(1)=x(2) velocidad articular
        qpp1];  %xp(2)=qpp  aceleracin articular
end

