
%Mecatrnica. Control y Automatizacin. 2013
%Fernando Reyes Corts, Jaime Cid Monjaraz y Emilio Vargas Soto
%Alfaomega  "Te acerca al conocimiento"

function [tau, qt] = saturado3gdl(q,qp)
q1=q(1);  
q2=q(2); 
q3=q(3); 

qp1=qp(1); 
qp2=qp(2); 
qp3=qp(3); 

%parmetros del vector de par gravitacional
m1=26.902; l1=0.45; m2=30; l2=0.45; lc2=0.038; 
m3=3.880; l3=0.45; lc3=0.048; g=9.81;   

%par gravitacional articular  
 par_grav=g*[0; (lc2*m2++m3*l3)*sin(q2)+m3*lc3*sin(q2+q3); m3*lc3*sin(q2+q3)]; 
 
 %vector de posicin deseada
 qd=[45*pi/180; 45*pi/180; 90*pi/180];
 %vector error de posicin
qt=[qd(1)-q1;qd(2)-q2; qd(3)-q3];

%lmites fsicos de los servoamplificadores
tau_max1=50;
tau_max2=150;
tau_max3=15;

%sintona de las ganancia proporcional
kp1=0.8*tau_max1;
kp2=0.8*tau_max2;
kp3=0.8*tau_max3;
Kp=[kp1, 0,0;0, kp2,0; 0,0,kp3]; 

%sintona de las ganancia derivativa
kv1=0.5*kp1;
kv2=0.5*kp2;
kv3=0.5*kp3;
Kv=[kv1, 0,0;0, kv2,0;0,0,kv3]; 
tau=Kp*atan(qt)-Kv*atan(qp)+par_grav;
%tau=Kp*qt./sqrt(1+qt.*qt)-Kv*qp./sqrt(1+qp.*qp)+par_grav;
end

