%Mecatrnica. Control y Automatizacin. 2013
%Fernando Reyes Corts, Jaime Cid Monjaraz y Emilio Vargas Soto
%Alfaomega  "Te acerca al conocimiento"


function [tau, qtilde] = saturado(q,qp)

q1=q(1);  
q2=q(2); 

qp1=qp(1); 
qp2=qp(2); 

%par gravitacional articular
  par_grav=(9.81*[3.9211*sin(q1)+0.1862*sin(q1+q2); 
    0.1862*sin(q1+q2)]);

qd=(pi/180)*[45 ;
             90];

%ganancia proporcional
tau_max1=150;
tau_max2=15;
kp1=0.8*tau_max1; 
kp2=0.8*tau_max2;
Kp=[kp1, 0; 
     0, kp2];  %ganancia proporcional

%ganancia derivativa
kv1=0.5*kp1; kv2=0.5*kp2;
Kv=[kv1,  0; 
    0, kv2]; %ganancia derivativa

qtilde=qd-q;
tau=Kp*sinh(qtilde)./(1+cosh(qtilde))-Kv*sinh(qp)./(1+cosh(qp))+par_grav;
end

