%Mecatrnica. Control y Automatizacin. 2013
%Fernando Reyes Corts, Jaime Cid Monjaraz y Emilio Vargas Soto
%Alfaomega  "Te acerca al conocimiento"

function [tau1, qt1] = tanhpendulo(q1,qp1)
%variables de estados (entradas)q1 es la posicin articular
%  qp1 representa la velocidad articular
     
%parmetros de la compensacin de gravedad del pndulo
     m1=5;      %masa
    lc1=0.01;  %centro de gravedad
    g=9.81;   %constante de aceleracin gravitacional
%vector de par de gravitacional --------------------------------------
    par_grav = m1*g*lc1*sin(q1);

 %ganancias del controlador ----------------------------------------------
    qd1=90;% posicin deseada en grados
    
    tau_max=15;
    kp1= 0.8*tau_max;% regla de sintona para la ganancia proporcional
    
    kv1=kp1; % regla de sintona para la ganancia derivativa
    
    qt1=pi*qd1/180-q1;  %error de posicin
%control tanhgente hiperblica 

%tau1=kp1*(qt1/(1+qt1*qt1))-kv1*(qp1/(1+qp1*qp1))+par_grav;
tau1=kp1*tanh(qt1)-kv1*tanh(qp1)+par_grav;
%tau1=kp1*atan(qt1)-kv1*atan(qp1)+par_grav;
%tau1=kp1*sinh(qt1)-kv1*sinh(qp1)+par_grav;
%tau1=kp1*(sign(qt1)/(1+abs(qt1)))-kv1*(qp1/(1+abs(qp1)))+par_grav;
%tau1=kp1*sign(qt1)-kv1*sign(qp1)+par_grav;
%tau1=kp1*qt1^3-kv1*qp1^3+par_grav;

end

